
defaults = {
	["name"]			= "ManaBreak",
	["author"]			= "Grognaz",
	["version"]			= 112,
}

function ManaBreak:Options(self)
	if ManaBreakDB == nil
	or ManaBreakDB.version ~= defaults.version
	then

	    --clear all the old values
	    ManaBreakDB = {};
		self:Print("|cFF00FF00" ..defaults.name ..": |r- Default Options - " .."|cFFFF0000Loaded")

		ManaBreakDB = {
            version = 112,
            name = "ManaBreak",
            handler = ManaBreak,
            type = 'group',
            args = {
                msg = {
                    type = 'input',
                    name = 'My Message',
                    desc = 'The message for my addon',
                    set = 'SetMyMessage',
                    get = 'GetMyMessage',
                },
            },

            active = 1,
            debug = 0, debugframe = 0,
            minHealerMana = 5000,
            safeRange = 70, criticalRange = 20,
            warnR = 0.8, warnG = 0.8, warnB = 0.1,
            critR = 0.8, critG = 0.1, critB = 0.1,

            ManaBreakFrame = {
                Name = "ManaBreakFrame",
                inherit = "",
                Type = "Frame",
                Mouse = true,
                Move = true,
                Clamped = true,
                Point = "CENTER", Anchor = "UIParent", RelativePoint = "CENTER",
                Strata = "BACKGROUND",
                height = 14, width = 160,
                x = 0, y = 0,
                r = 0, g = 0, b = 0, a = 0.5,
                br = 0.5, bg = 0.5, bb = 0.5, ba = 0,
                alpha = 1,
                scale = 1,
                backdrop = {
                    bgFile = "Interface/Tooltips/UI-Tooltip-Background",
                    edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
                    tile = false, tileSize = 0, edgeSize = 0,
                    insets = {
                        left = 0, right = 0, top = 0, bottom = 0,
                    },
                },
            },

            HealerManaTexture = {
                Name = "HealerManaTexture",
                Parent = "ManaBreakFrame",
                Inherits = "",
                Point = "LEFT", Anchor = "ManaBreakFrame", RelativePoint = "LEFT",
                height = 14, width = 160,
                x = 0, y = 0,
                r = 0.1, g = 0.6 , b = 0.0, a = 1.0,
            },

            ManaBreakBorder = {
                Name = "ManaBreakBorder",
                inherit = "",
                Type = "Frame",
                Mouse = false,
                Move = true,
                Clamped = true,
                Point = "CENTER", Anchor = "ManaBreakFrame", RelativePoint = "CENTER",
                Strata = "LOW",
                height = 22, width = 168,
                x = 0, y = 0,
                r = 0, g = 0, b = 0, a = 0,
                br = 0.5, bg = 0.5, bb = 0.5, ba = 1.0,
                alpha = 1,
                scale = 1,
                backdrop = {
                    bgFile = "Interface/Tooltips/UI-Tooltip-Background",
                    edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
                    tile = true, tileSize = 16, edgeSize = 16,
                    insets = {
                        left = 8, right = 8, top = 8, bottom = 8,
                    },
                },
            },

            HealerManaText = {
                Name = "HealerManaText",
                Parent = "ManaBreakBorder",
                --LayerLevel = "OVERLAY",
                Inherits = nil,
                Point = "BOTTOM", Anchor = "ManaBreakBorder", RelativePoint = "BOTTOM",
                Strata = "LOW",
                x = 0, y = 4,
                text = "Healers",
                Font = "Fonts\\ARIALN.TTF", FontSize = 14, FontFlag = "OUTLINE",
                r = 1, g = 1, b = 1, a = 1,
                start = 0, length = 0,
            },
            ManaBreakDebugFrame = {
                Name = "ManaBreakDebugFrame",
                inherit = "",
                Type = "Frame",
                Mouse = true,
                Move = true,
                Clamped = true,
                Point = "CENTER", Anchor = "UIParent", RelativePoint = "CENTER",
                Strata = "BACKGROUND",
                height = 100, width = 100,
                x = 600, y = 200,
                r = 0, g = 0, b = 0, a = 1.0,
                br = 0.5, bg = 0.5, bb = 0.5, ba = 1,
                alpha = 1,
                scale = 1,
                backdrop = {
                    bgFile = "Interface/Tooltips/UI-Tooltip-Background", --Interface/Tooltips/UI-Tooltip-Background
                    edgeFile = "Interface/Tooltips/UI-Tooltip-Border", --Interface/Tooltips/UI-Tooltip-Border
                    tile = true, tileSize = 16, edgeSize = 16,
                    insets = {
                        left = 4, right = 4, top = 4, bottom = 4,
                    },
                },
            },


            DebugText = {
                Name = "DebugText",
                Parent = "ManaBreakDebugFrame",
                LayerLevel = "BORDER",
                Inherits = "GameFontNormal",
                Point = "TOP", Anchor = "ManaBreakDebugFrame", RelativePoint = "TOP",
                x = 0, y = -10,
                text = "DebugText",
                Font = "FRIZQT__.TTF", FontSize = 30, FontFlag = "THINOUTLINE",
                r = 0.8, g = 0.8, b = 1.0, a = 1,
                start = 0, length = 0,

            },
        }
	else
		ManaBreakDB = ManaBreakDB
	end
    LibStub("AceConfig-3.0"):RegisterOptionsTable("ManaBreak", ManaBreakDB, {"ManaBreak", "rs"})
end







function ManaBreak:GetMyMessage(info)
    return myMessageVar
end

function ManaBreak:SetMyMessage(info, input)
    myMessageVar = input
    self:Print(myMessageVar)
end




