
function ManaBreak:ManaColor(power, maxpower)
	local safeRange = ManaBreakDB.safeRange
	local safeRange = (0.01 * safeRange)
	local criticalRange = ManaBreakDB.criticalRange
	local criticalRange = (0.01 * criticalRange)

	local t = ManaBreakDB.HealerManaTexture
	local r, g, b = t.r, t.g, t.b
	local warnR, warnG, warnB = ManaBreakDB.warnR, ManaBreakDB.warnG, ManaBreakDB.warnB
	local critR, critG, critB = ManaBreakDB.critR, ManaBreakDB.critG, ManaBreakDB.critB
	local color =  (1 / maxpower * power)

	if color >= safeRange then
		r, g, b = r, g, b
	elseif color < safeRange and color > criticalRange then
		local rangeFull = safeRange - criticalRange
		local medianRange = rangeFull / 2 + criticalRange
		local rangeHigh = safeRange - medianRange
		local rangeLow = medianRange - criticalRange
		-- set color to range above 50%
		if color >= medianRange then
			local newR = r - warnR
			local newG = g - warnG
			local newB = b - warnB
			warnR = ((color - medianRange) / rangeHigh) * newR + warnR
			warnG = ((color - medianRange) / rangeHigh) * newG + warnG
			warnB = ((color - medianRange) / rangeHigh) * newB + warnB
		else --set color range to below 50%
			local newR = warnR - critR
			local newG = warnG - critG
			local newB = warnB - critB
			warnR = ((color - criticalRange) / rangeLow) * newR + critR
			warnG = ((color - criticalRange) / rangeLow) * newG + critG
			warnB = ((color - criticalRange) / rangeLow) * newB + critB
		end
		r, g, b = warnR, warnG, warnB
	elseif color <= criticalRange then
		r, g, b = critR, critG, critB
	else
		r, g, b = critR, critG, critB
	end

	return r,g,b
end


function ClassColor(unit, frameName)
	local playerClass, englishClass = UnitClass(unit)
	if (englishClass=="DRUID") then
			frameName:SetTextColor(1.0, 0.49, 0.04, 1.0)
	elseif (englishClass=="HUNTER") then
			frameName:SetTextColor(0.67, 0.83, 0.45, 1.0)
	elseif (englishClass=="MAGE") then
			frameName:SetTextColor(0.41, 0.8, 0.94, 1.0)
	elseif (englishClass=="PALADIN") then
			frameName:SetTextColor(0.96, 0.55, 0.73, 1.0)
	elseif (englishClass=="PRIEST") then
			frameName:SetTextColor(1.0, 1.0, 1.0, 1.0)
	elseif (englishClass=="ROGUE") then
			frameName:SetTextColor(1.0, 0.96, 0.41, 1.0)
	elseif (englishClass=="SHAMAN") then
			frameName:SetTextColor(0.14, 0.35, 1.0, 1.0)
	elseif (englishClass=="WARLOCK") then
			frameName:SetTextColor(0.58, 0.51, 0.79, 1.0)
	elseif (englishClass=="WARRIOR") then
			frameName:SetTextColor(0.78, 0.61, 0.43, 1.0)
	end
end


function PowerTypeColor(unit, frameName)
	local power = UnitPowerType(unit)
	if (power==0) then
		frameName:SetTextColor(0, 0, 1, 1)
	elseif (power==1) then
		frameName:SetTextColor(1, 0, 0, 1)
	elseif (power==2) then
		frameName:SetTextColor(1, 1, 0, 1)
	elseif (power==3) then
		frameName:SetTextColor(1, 1, 0, 1)
	end
end




