    --[[	frame				##
	name
	toplevel
	movable
	parent
	enablemouse
	hidden
	virtual
	setallpoints
	inherits		"UIDropDownMenuTemplate", SecureUnitButtonTemplate, SecureActionButtonTemplate
	id
	framestrata
	enablekeyboard
	alpha
	clampedtoscreen
	protected
    --]]
function FrameBuilder(input)
	--Type, Mouse, Move, Clamped, backdrop, Name, Point, Anchor, RelativePoint, Strata, height, width, x, y, r, g, b, a
		--[[TYPEs:
		Button(API)
		Cooldown(API)
		ColorSelect(API)
		EditBox(API)
		GameTooltip(API)
		MessageFrame(API)
		Minimap(API)
		Model(API)
		ScrollFrame(API)
		ScrollingMessageFrame(API)
		SimpleHTML(API)
		Slider(API)
		StatusBar(API)
		--]]
	local object = CreateFrame(input.Type, input.Name, _G[input.Anchor], input.inherit)		--("frameType"[, "frameName"[, parentFrame[, "inheritsFrame"]--[[) "SecureUnitButtonTemplate"
	object:ClearAllPoints()
	object:SetFrameStrata(input.Strata)
	object:SetPoint(input.Point, _G[input.Anchor], input.RelativePoint, input.x, input.y)
	object:SetHeight(input.height)
	object:SetWidth(input.width)
	object:SetBackdrop(input.backdrop)
	object:SetBackdropColor(input.r, input.g, input.b, input.a)
	object:SetBackdropBorderColor(input.br, input.bg, input.bb, input.ba)
	object:SetAlpha(input.alpha)
	object:SetScale(input.scale)
	object:EnableMouse(input.Mouse)
	object:SetMovable(input.Move)
	object:SetClampedToScreen(input.Clamped)
end




    --[[	checkbutton		##
	name
	"OptionsCheckButtonTemplate"
	virtual
	parent
	id
	hidden
	framestrata
	checked
    --]]
function CheckButtonBuilder(input)
	--Parent, Name, Point, Anchor, RelativePoint, x, y, height, width, backdrop, r, g, b, a, state
	local checkbutton = CreateFrame("CheckButton", input.Name, _G[input.Anchor], "OptionsCheckButtonTemplate")
	checkbutton:ClearAllPoints()
	checkbutton:SetPoint(input.Point, _G[input.Anchor], input.RelativePoint, input.x, input.y)
	checkbutton:SetHeight(input.height)
	checkbutton:SetWidth(input.width)
	checkbutton:SetBackdrop(input.backdrop)
	checkbutton:SetBackdropColor(input.r, input.g, input.b, input.a)
	checkbutton:SetBackdropBorderColor(input.br, input.bg, input.bb, input.ba)
	checkbutton:SetChecked(input.state)
end


    --[[	fontstring			##
	name
	inherits
	justifyh
	text
	justifyv
	hidden
	nonspacewrap
	bytes
	virtual
	maxlines
    --]]
function FontstringBuilder(input)
	--Parent, Name, LayerLevel, Inherits, Point, Anchor, RelativePoint, x, y, text, Font, FontSize, FontFlag, r, g, b, a, start, length
	local object = _G[input.Parent]:CreateFontString(input.Name, input.LayerLevel, input.Inherits) -- "OVERLAY" / "GameFontNormal"
	object:ClearAllPoints()
	object:SetPoint(input.Point, _G[input.Anchor], input.RelativePoint, input.x, input.y)
	object:SetFont(input.Font, input.FontSize, input.FontFlag)		--OUTLINE,  THICKOUTLINE and/or MONOCHROME
	object:SetText(input.text)
	object:SetTextColor(input.r, input.g, input.b, input.a)
	--object:SetAlphaGradient(input.start, input.length)	--start,  length	If the length is 0, the text is returned to normal.

	--object:SetJustifyH("justifyH") -- Sets horizontal text justification ("LEFT","RIGHT", or "CENTER")
	--object:SetJustifyV("justifyV") -- Sets vertical text justification ("TOP","BOTTOM", or "MIDDLE")
end


	--[[	texture			##
	name
	file
	hidden
	alphamode
	setallpoints
	virtual
	inherits
	--]]
function TextureBuilder(input)
	--Name, Parent, Point, Anchor, RelativePoint, LayerLevel, height, width, x, y, r, g, b, a
	local object = _G[input.Parent]:CreateTexture(input.Name)  --"BORDER"
	object:ClearAllPoints()
	object:SetPoint(input.Point, _G[input.Anchor], input.RelativePoint, input.x, input.y)
	object:SetHeight(input.height)
	object:SetWidth(input.width)
	object:SetColorTexture(input.r, input.g, input.b, input.a)

end
