ManaBreak = LibStub("AceAddon-3.0"):NewAddon("ManaBreak", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")

--local ManaBreak = ManaBreak


function ManaBreak:OnInitialize()
  -- Code that you want to run when the addon is first loaded goes here. (saved settings,...)
    self.db = LibStub("AceDB-3.0"):New("ManaBreakDB")

    local frame = CreateFrame("FRAME");
    frame:RegisterEvent("ADDON_LOADED");


end


function ManaBreak:OnEnable()
    -- Called when the addon is enabled
    self:RegisterEvent("UNIT_POWER_UPDATE")
    self:Options(self)
    self:Print("is enabled.")

    if ManaBreakDB.active==1 then
        self:BuildFrames()
    end

end


function ManaBreak:OnDisable()
    -- Called when the addon is disabled
end


function ManaBreak:UNIT_POWER_UPDATE()
    self:GetUnitPower()
end


function ManaBreak:BuildFrames()
    FrameBuilder(ManaBreakDB.ManaBreakFrame)
    if (ManaBreakDB.ManaBreakFrame.Move == true) then
		local frame = _G[ManaBreakDB.ManaBreakFrame.Name]
        self:DragFrame(frame)
	end
	TextureBuilder(ManaBreakDB.HealerManaTexture)
    FrameBuilder(ManaBreakDB.ManaBreakBorder)
	FontstringBuilder(ManaBreakDB.HealerManaText)


    if ManaBreakDB.debugframe == 1 then
        FrameBuilder(ManaBreakDB.ManaBreakDebugFrame)
        if (ManaBreakDB.ManaBreakDebugFrame.Move == true) then
            local frame = _G[ManaBreakDB.ManaBreakDebugFrame.Name]
            self:DragFrame(frame)
        end
        FontstringBuilder(ManaBreakDB.DebugText)
    end

    ManaBreak:Print("Frames Built")
end


function ManaBreak:DragFrame(frame)
	frame:SetScript("OnMouseDown",function()
		frame:StartMoving()
        --
	end)
	frame:SetScript("OnMouseUp",function()
		frame:StopMovingOrSizing()
			-- set new coordinates
            local f =  ManaBreakDB.ManaBreakFrame
            --point, relativeTo, relativePoint, xOfs, yOfs
             f.Point, _, f.RelativePoint, f.x, f.y = frame:GetPoint(1)
            --self:Print(f.Point, f.RelativePoint, f.x, f.y)
	end)
end



local t = {[0] = "mana", [1] = "rage", [2] = "focus", [3] = "energy"};
local updates = 0

--name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitBuff("unit", index or ["name", "rank"][, "filter"])

function ManaBreak:GetUnitPower()
    local members = GetNumGroupMembers()
    local unitName
    local refresh

    if members > 0 then
        refresh = math.ceil(0.25 * members)
    else
        refresh = 1
    end

    if updates == refresh then
        --self:Print(members, refresh)
        local GroupHealerMana = {['now']={}, ['max']={}, ['unit']={}}
        for raidIndex = 1, members do
            if GetRaidRosterInfo(raidIndex) then
                unitName = GetRaidRosterInfo(raidIndex)
                if ( CheckInteractDistance(unitName, 4) ) then
                    --local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(raidIndex)
                    local name, _, _, _, class, _, _, online, isDead, _, _ = GetRaidRosterInfo(raidIndex)
                    --self:Print(raidIndex .. ": " .. GetRaidRosterInfo(raidIndex).. ": " ..t[UnitPowerType(unitName)] .. " " .. UnitPower(unitName).." / "..UnitPowerMax(unitName))

                    if t[UnitPowerType(unitName)] == "mana" then
                        --limit to potential healers by minimum amount of mana
                        if UnitPowerMax(unitName) > ManaBreakDB.minHealerMana then

                            if class == "Priest" then
                                local shadow = false
                                local spellname = "Shadowform"
                                for i=1,40 do
                                    local name=UnitAura(unitName, i)
                                    if name == spellname then
                                        shadow = true
                                    end
                                end
                                if shadow == false then
                                    --self:Print("heal priest: ", unitName)
                                    GroupHealerMana['now'][raidIndex] = UnitPower(unitName)
                                    GroupHealerMana['max'][raidIndex] = UnitPowerMax(unitName)
                                    GroupHealerMana['unit'][unitName] = unitName
                                else
                                    --self:Print("shadow priest: ", unitName)
                                end
                            end

                            if (class == "Shaman" or class == 'Druid' or class == 'Paladin') then
                                GroupHealerMana['now'][raidIndex] = UnitPower(unitName)
                                GroupHealerMana['max'][raidIndex] = UnitPowerMax(unitName)
                                GroupHealerMana['unit'][unitName] = unitName
                            end
                        end
                    end
                end
            end
        end


        local width = (ManaBreakDB.ManaBreakFrame.width)
        if GetRaidRosterInfo(1) then
            local HealerMana = ManaBreak:SumTable(GroupHealerMana['now'])
            local MaxHealerMana = ManaBreak:SumTable(GroupHealerMana['max'])
            local r, g, b = self:ManaColor(HealerMana, MaxHealerMana)

            HealerManaText:SetText("Healers: "  .. ManaBreak:getTableSize(GroupHealerMana['now'])
                                    .."\n" .. math.floor(100 / MaxHealerMana * HealerMana) .." %")
            HealerManaTexture:SetWidth(width / MaxHealerMana * HealerMana)
            --HealerManaText:SetTextColor(r, g, b)
            HealerManaTexture:SetColorTexture(r, g, b)
        else
            local unitName = "player"
            local power = UnitPower(unitName)
            local maxpower = UnitPowerMax(unitName)
            local percentage = math.floor(100 / maxpower * power)
            local width = (width / maxpower * power)
            local r,g,b = self:ManaColor(power, maxpower)

            HealerManaText:SetText(percentage .."%")
            HealerManaTexture:SetWidth(width)
            --HealerManaText:SetTextColor(r, g, b)
            HealerManaTexture:SetColorTexture(r, g, b)

            --self:Print(r, g, b, 1.0)

            --self:Print("------------------")
        end


        if ManaBreakDB.debug == 1 then
            self:Print(ManaBreak:getTableSize(GroupHealerMana['now']) .. " --------------------")
            self:Print(ManaBreak:getTableSize(GroupHealerMana['max']) .. " --------------------")
            self:Print(ManaBreak:getTableSize(GroupHealerMana['unit']) .. " --------------------")
            self:Print((ManaBreak:getTableSize(GroupRage['max']) + ManaBreak:getTableSize(GroupEnergy['max'])) .. " --------------------")
            for i,v in ipairs(GroupHealerMana['now']) do
                self:Print(i,v)
            end
        end
        updates = 0
    else
        if ManaBreakDB.debugframe == 1 then
--[[            local r,g,b = self:ManaColor(power, maxpower)
            DebugText:SetText("DebugText: "
                    .."\ngroup size: " .. members
                    .."\nudpates: " .. updates
                    --.."\n strata: " .. HealerManaTexture:GetFrameStrata()
                    --.."\n framelevel: " .. HealerManaTexture:GetFrameLevel()
                    --.. "\n r: " .. r
            )]]
        end
        updates = updates +1
    end
end


function ManaBreak:SumTable(table)
   local sum = 0
   for k,v in pairs(table) do
      sum = sum + v
   end
   return sum
end

function ManaBreak:getTableSize(table)
   local count = 0
   for _, _ in pairs(table) do
      count = count + 1
   end
   return count
end


function ButtonStatus(button)
	button:SetScript("OnEnter",function()  button:SetScale(1.2)end)
	button:SetScript("OnLeave",function()  button:SetScale(1) end)
end











